var Native = function(n) {
		n = n || {};
		var a = n.name;
		var l = n.legacy;
		var b = n.protect;
		var c = n.implement;
		var k = n.generics;
		var g = n.initialize;
		var h = n.afterImplement ||
		function() {};
		var d = g || l;
		k = k !== false;
		d.constructor = Native;
		d.$family = {
			name: "native"
		};
		if (l && g) {
			d.prototype = l.prototype
		}
		d.prototype.constructor = d;
		if (a) {
			var f = a.toLowerCase();
			d.prototype.$family = {
				name: f
			};
			Native.typize(d, f)
		}
		var m = function(q, o, r, p) {
				if (!b || p || !q.prototype[o]) {
					q.prototype[o] = r
				}
				if (k) {
					Native.genericize(q, o, b)
				}
				h.call(q, o, r);
				return q
			};
		d.alias = function(q, o, r) {
			if (typeof q == "string") {
				if ((q = this.prototype[q])) {
					return m(this, o, q, r)
				}
			}
			for (var p in q) {
				this.alias(p, q[p], o)
			}
			return this
		};
		d.implement = function(q, o, s) {
			if (typeof q == "string") {
				return m(this, q, o, s)
			}
			for (var r in q) {
				m(this, r, q[r], o)
			}
			return this
		};
		if (c) {
			d.implement(c)
		}
		return d
	};
Native.genericize = function(b, c, a) {
	if ((!a || !b[c]) && typeof b.prototype[c] == "function") {
		b[c] = function() {
			var d = Array.prototype.slice.call(arguments);
			return b.prototype[c].apply(d.shift(), d)
		}
	}
};
Native.implement = function(d, c) {
	for (var b = 0, a = d.length; b < a; b++) {
		d[b].implement(c)
	}
};
Native.typize = function(a, b) {
	if (!a.type) {
		a.type = function(c) {
			return ($type(c) === b)
		}
	}
};
(function() {
	var a = {
		Array: Array,
		Date: Date,
		Function: Function,
		Number: Number,
		RegExp: RegExp,
		String: String
	};
	for (var k in a) {
		new Native({
			name: k,
			initialize: a[k],
			protect: true
		})
	}
	var d = {
		"boolean": Boolean,
		"native": Native,
		object: Object
	};
	for (var c in d) {
		Native.typize(d[c], c)
	}
	var h = {
		Array: ["concat", "indexOf", "join", "lastIndexOf", "pop", "push", "reverse", "shift", "slice", "sort", "splice", "toString", "unshift", "valueOf"],
		String: ["charAt", "charCodeAt", "concat", "indexOf", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "valueOf"]
	};
	for (var f in h) {
		for (var b = h[f].length; b--;) {
			Native.genericize(window[f], h[f][b], true)
		}
	}
})();

var Hash = new Native({
	name: "Hash",
	initialize: function(a) {
		if ($type(a) == "hash") {
			a = $unlink(a.getClean())
		}
		for (var b in a) {
			this[b] = a[b]
		}
		return this
	}
});
Hash.implement({
	forEach: function(b, c) {
		for (var a in this) {
			if (this.hasOwnProperty(a)) {
				b.call(c, this[a], a, this)
			}
		}
	},
	getClean: function() {
		var b = {};
		for (var a in this) {
			if (this.hasOwnProperty(a)) {
				b[a] = this[a]
			}
		}
		return b
	},
	getLength: function() {
		var b = 0;
		for (var a in this) {
			if (this.hasOwnProperty(a)) {
				b++
			}
		}
		return b
	}
});
Hash.alias("forEach", "each");
Array.implement({
	forEach: function(c, d) {
		for (var b = 0, a = this.length; b < a; b++) {
			c.call(d, this[b], b, this)
		}
	}
});
Array.alias("forEach", "each");

function $A(c) {
	if (c.item) {
		var d = [];
		for (var b = 0, a = c.length; b < a; b++) {
			d[b] = c[b]
		}
		return d
	}
	return Array.prototype.slice.call(c)
}
function $arguments(a) {
	return function() {
		return arguments[a]
	}
}
function $chk(a) {
	return !!(a || a === 0)
}
function $clear(a) {
	clearTimeout(a);
	clearInterval(a);
	return null
}
function $defined(a) {
	return (a != undefined)
}
function $each(c, b, d) {
	var a = $type(c);
	((a == "arguments" || a == "collection" || a == "array") ? Array : Hash).each(c, b, d)
}
function $empty() {}
function $extend(c, a) {
	for (var b in (a || {})) {
		c[b] = a[b]
	}
	return c
}
function $H(a) {
	return new Hash(a)
}
function $lambda(a) {
	return (typeof a == "function") ? a : function() {
		return a
	}
}
function $merge() {
	var f = {};
	for (var d = 0, a = arguments.length; d < a; d++) {
		var b = arguments[d];
		if ($type(b) != "object") {
			continue
		}
		for (var c in b) {
			var h = b[c],
				g = f[c];
			f[c] = (g && $type(h) == "object" && $type(g) == "object") ? $merge(g, h) : $unlink(h)
		}
	}
	return f
}
function $pick() {
	for (var b = 0, a = arguments.length; b < a; b++) {
		if (arguments[b] != undefined) {
			return arguments[b]
		}
	}
	return null
}
function $random(b, a) {
	return Math.floor(Math.random() * (a - b + 1) + b)
}
function $splat(b) {
	var a = $type(b);
	return (a) ? ((a != "array" && a != "arguments") ? [b] : b) : []
}
var $time = Date.now ||
function() {
	return +new Date
};

function $try() {
	for (var b = 0, a = arguments.length; b < a; b++) {
		try {
			return arguments[b]()
		} catch (c) {}
	}
	return null
}
function $type(a) {
	if (a == undefined) {
		return false
	}
	if (a.$family) {
		return (a.$family.name == "number" && !isFinite(a)) ? false : a.$family.name
	}
	if (a.nodeName) {
		switch (a.nodeType) {
		case 1:
			return "element";
		case 3:
			return (/\S/).test(a.nodeValue) ? "textnode" : "whitespace"
		}
	} else {
		if (typeof a.length == "number") {
			if (a.callee) {
				return "arguments"
			} else {
				if (a.item) {
					return "collection"
				}
			}
		}
	}
	return typeof a
}
function $unlink(c) {
	var b;
	switch ($type(c)) {
	case "object":
		b = {};
		for (var f in c) {
			b[f] = $unlink(c[f])
		}
		break;
	case "hash":
		b = new Hash(c);
		break;
	case "array":
		b = [];
		for (var d = 0, a = c.length; d < a; d++) {
			b[d] = $unlink(c[d])
		}
		break;
	default:
		return c
	}
	return b
}
var Browser = $merge({
	Engine: {
		name: "unknown",
		version: 0
	},
	Platform: {
		name: (window.orientation != undefined) ? "ipod" : (navigator.platform.match(/mac|win|linux/i) || ["other"])[0].toLowerCase()
	},
	Features: {
		xpath: !! (document.evaluate),
		air: !! (window.runtime),
		query: !! (document.querySelector)
	},
	Plugins: {},
	Engines: {
		presto: function() {
			return (!window.opera) ? false : ((arguments.callee.caller) ? 960 : ((document.getElementsByClassName) ? 950 : 925))
		},
		trident: function() {
			return (!window.ActiveXObject) ? false : ((window.XMLHttpRequest) ? ((navigator.appVersion.match(/10./i) == "10.") ? 8 : ((navigator.appVersion.match(/9./i) == "9.") ? 7 : ((document.querySelectorAll) ? 6 : 5))) : (navigator.appVersion.indexOf("MSIE 8.0") != -1 ? 6 : 4))
		},
		webkit: function() {
			return (navigator.taintEnabled) ? false : ((Browser.Features.xpath) ? ((Browser.Features.query) ? 525 : 420) : 419)
		},
		gecko: function() {
			return (!document.getBoxObjectFor && window.mozInnerScreenX == null) ? false : ((document.getElementsByClassName) ? 19 : 18)
		}
	}
}, Browser || {});
Browser.Platform[Browser.Platform.name] = true;
Browser.detect = function() {
	for (var b in this.Engines) {
		var a = this.Engines[b]();
		if (a) {
			this.Engine = {
				name: b,
				version: a
			};
			this.Engine[b] = this.Engine[b + a] = true;
			break
		}
	}
	return {
		name: b,
		version: a
	}
};
Browser.detect();
Browser.Request = function() {
	return $try(function() {
		return new XMLHttpRequest()
	}, function() {
		return new ActiveXObject("MSXML2.XMLHTTP")
	}, function() {
		return new ActiveXObject("Microsoft.XMLHTTP")
	})
};
Browser.Features.xhr = !! (Browser.Request());
Browser.Plugins.Flash = (function() {
	var a = ($try(function() {
		return navigator.plugins["Shockwave Flash"].description
	}, function() {
		return new ActiveXObject("ShockwaveFlash.ShockwaveFlash").GetVariable("$version")
	}) || "0 r0").match(/\d+/g);
	return {
		version: parseInt(a[0] || 0 + "." + a[1], 10) || 0,
		build: parseInt(a[2], 10) || 0
	}
})();

function $exec(b) {
	if (!b) {
		return b
	}
	if (window.execScript) {
		window.execScript(b)
	} else {
		var a = document.createElement("script");
		a.setAttribute("type", "text/javascript");
		a[(Browser.Engine.webkit && Browser.Engine.version < 420) ? "innerText" : "text"] = b;
		document.head.appendChild(a);
		document.head.removeChild(a)
	}
	return b
}

Array.implement({
	every: function(c, d) {
		for (var b = 0, a = this.length; b < a; b++) {
			if (!c.call(d, this[b], b, this)) {
				return false
			}
		}
		return true
	},
	filter: function(d, f) {
		var c = [];
		for (var b = 0, a = this.length; b < a; b++) {
			if (d.call(f, this[b], b, this)) {
				c.push(this[b])
			}
		}
		return c
	},
	clean: function() {
		return this.filter($defined)
	},
	indexOf: function(c, d) {
		var a = this.length;
		for (var b = (d < 0) ? Math.max(0, a + d) : d || 0; b < a; b++) {
			if (this[b] === c) {
				return b
			}
		}
		return -1
	},
	map: function(d, f) {
		var c = [];
		for (var b = 0, a = this.length; b < a; b++) {
			c[b] = d.call(f, this[b], b, this)
		}
		return c
	},
	some: function(c, d) {
		for (var b = 0, a = this.length; b < a; b++) {
			if (c.call(d, this[b], b, this)) {
				return true
			}
		}
		return false
	},
	associate: function(c) {
		var d = {},
			b = Math.min(this.length, c.length);
		for (var a = 0; a < b; a++) {
			d[c[a]] = this[a]
		}
		return d
	},
	link: function(c) {
		var a = {};
		for (var f = 0, b = this.length; f < b; f++) {
			for (var d in c) {
				if (c[d](this[f])) {
					a[d] = this[f];
					delete c[d];
					break
				}
			}
		}
		return a
	},
	contains: function(a, b) {
		return this.indexOf(a, b) != -1
	},
	extend: function(c) {
		for (var b = 0, a = c.length; b < a; b++) {
			this.push(c[b])
		}
		return this
	},
	getLast: function() {
		return (this.length) ? this[this.length - 1] : null
	},
	getRandom: function() {
		return (this.length) ? this[$random(0, this.length - 1)] : null
	},
	include: function(a) {
		if (!this.contains(a)) {
			this.push(a)
		}
		return this
	},
	combine: function(c) {
		for (var b = 0, a = c.length; b < a; b++) {
			this.include(c[b])
		}
		return this
	},
	erase: function(b) {
		for (var a = this.length; a--; a) {
			if (this[a] === b) {
				this.splice(a, 1)
			}
		}
		return this
	},
	empty: function() {
		this.length = 0;
		return this
	},
	flatten: function() {
		var d = [];
		for (var b = 0, a = this.length; b < a; b++) {
			var c = $type(this[b]);
			if (!c) {
				continue
			}
			d = d.concat((c == "array" || c == "collection" || c == "arguments") ? Array.flatten(this[b]) : this[b])
		}
		return d
	},
	hexToRgb: function(b) {
		if (this.length != 3) {
			return null
		}
		var a = this.map(function(c) {
			if (c.length == 1) {
				c += c
			}
			return c.toInt(16)
		});
		return (b) ? a : "rgb(" + a + ")"
	},
	rgbToHex: function(d) {
		if (this.length < 3) {
			return null
		}
		if (this.length == 4 && this[3] == 0 && !d) {
			return "transparent"
		}
		var b = [];
		for (var a = 0; a < 3; a++) {
			var c = (this[a] - 0).toString(16);
			b.push((c.length == 1) ? "0" + c : c)
		}
		return (d) ? b : "#" + b.join("")
	}
});
Function.implement({
	extend: function(a) {
		for (var b in a) {
			this[b] = a[b]
		}
		return this
	},
	create: function(b) {
		var a = this;
		b = b || {};
		return function(d) {
			var c = b.arguments;
			c = (c != undefined) ? $splat(c) : Array.slice(arguments, (b.event) ? 1 : 0);
			if (b.event) {
				c = [d || window.event].extend(c)
			}
			var f = function() {
					return a.apply(b.bind || null, c)
				};
			if (b.delay) {
				return setTimeout(f, b.delay)
			}
			if (b.periodical) {
				return setInterval(f, b.periodical)
			}
			if (b.attempt) {
				return $try(f)
			}
			return f()
		}
	},
	run: function(a, b) {
		return this.apply(b, $splat(a))
	},
	pass: function(a, b) {
		return this.create({
			bind: b,
			arguments: a
		})
	},
	bindWithEvent: function(b, a) {
		return this.create({
			bind: b,
			arguments: a,
			event: true
		})
	},
	attempt: function(a, b) {
		return this.create({
			bind: b,
			arguments: a,
			attempt: true
		})()
	},
	delay: function(b, c, a) {
		return this.create({
			bind: c,
			arguments: a,
			delay: b
		})()
	},
	periodical: function(c, b, a) {
		return this.create({
			bind: b,
			arguments: a,
			periodical: c
		})()
	}
});
Function.prototype.bind = function(b, a) {
	return this.create({
		bind: b,
		arguments: a
	})
};
Number.implement({
	limit: function(b, a) {
		return Math.min(a, Math.max(b, this))
	},
	round: function(a) {
		a = Math.pow(10, a || 0);
		return Math.round(this * a) / a
	},
	times: function(b, c) {
		for (var a = 0; a < this; a++) {
			b.call(c, a, this)
		}
	},
	toFloat: function() {
		return parseFloat(this)
	},
	toInt: function(a) {
		return parseInt(this, a || 10)
	}
});
Number.alias("times", "each");
(function(b) {
	var a = {};
	b.each(function(c) {
		if (!Number[c]) {
			a[c] = function() {
				return Math[c].apply(null, [this].concat($A(arguments)))
			}
		}
	});
	Number.implement(a)
})(["abs", "acos", "asin", "atan", "atan2", "ceil", "cos", "exp", "floor", "log", "max", "min", "pow", "sin", "sqrt", "tan"]);
String.implement({
	test: function(a, b) {
		return ((typeof a == "string") ? new RegExp(a, b) : a).test(this)
	},
	contains: function(a, b) {
		return (b) ? (b + this + b).indexOf(b + a + b) > -1 : this.indexOf(a) > -1
	},
	trim: function() {
		return this.replace(/^\s+|\s+$/g, "")
	},
	clean: function() {
		return this.replace(/\s+/g, " ").trim()
	},
	camelCase: function() {
		return this.replace(/-\D/g, function(a) {
			return a.charAt(1).toUpperCase()
		})
	},
	hyphenate: function() {
		return this.replace(/[A-Z]/g, function(a) {
			return ("-" + a.charAt(0).toLowerCase())
		})
	},
	capitalize: function() {
		return this.replace(/\b[a-z]/g, function(a) {
			return a.toUpperCase()
		})
	},
	escapeRegExp: function() {
		return this.replace(/([-.*+?^${}()|[\]\/\\])/g, "\\$1")
	},
	toInt: function(a) {
		return parseInt(this, a || 10)
	},
	toFloat: function() {
		return parseFloat(this)
	},
	hexToRgb: function(b) {
		var a = this.match(/^#?(\w{1,2})(\w{1,2})(\w{1,2})$/);
		return (a) ? a.slice(1).hexToRgb(b) : null
	},
	rgbToHex: function(b) {
		var a = this.match(/\d{1,3}/g);
		return (a) ? a.rgbToHex(b) : null
	},
	stripScripts: function(b) {
		var a = "";
		var c = this.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function() {
			a += arguments[1] + "\n";
			return ""
		});
		if (b === true) {
			$exec(a)
		} else {
			if ($type(b) == "function") {
				b(a, c)
			}
		}
		return c
	},
	substitute: function(a, b) {
		return this.replace(b || (/\\?\{([^{}]+)\}/g), function(d, c) {
			if (d.charAt(0) == "\\") {
				return d.slice(1)
			}
			return (a[c] != undefined) ? a[c] : ""
		})
	}
});
Hash.implement({
	has: Object.prototype.hasOwnProperty,
	keyOf: function(b) {
		for (var a in this) {
			if (this.hasOwnProperty(a) && this[a] === b) {
				return a
			}
		}
		return null
	},
	hasValue: function(a) {
		return (Hash.keyOf(this, a) !== null)
	},
	extend: function(a) {
		Hash.each(a, function(c, b) {
			Hash.set(this, b, c)
		}, this);
		return this
	},
	combine: function(a) {
		Hash.each(a, function(c, b) {
			Hash.include(this, b, c)
		}, this);
		return this
	},
	erase: function(a) {
		if (this.hasOwnProperty(a)) {
			delete this[a]
		}
		return this
	},
	get: function(a) {
		return (this.hasOwnProperty(a)) ? this[a] : null
	},
	set: function(a, b) {
		if (!this[a] || this.hasOwnProperty(a)) {
			this[a] = b
		}
		return this
	},
	empty: function() {
		Hash.each(this, function(b, a) {
			delete this[a]
		}, this);
		return this
	},
	include: function(b, c) {
		var a = this[b];
		if (a == undefined) {
			this[b] = c
		}
		return this
	},
	map: function(b, c) {
		var a = new Hash;
		Hash.each(this, function(f, d) {
			a.set(d, b.call(c, f, d, this))
		}, this);
		return a
	},
	filter: function(b, c) {
		var a = new Hash;
		Hash.each(this, function(f, d) {
			if (b.call(c, f, d, this)) {
				a.set(d, f)
			}
		}, this);
		return a
	},
	every: function(b, c) {
		for (var a in this) {
			if (this.hasOwnProperty(a) && !b.call(c, this[a], a)) {
				return false
			}
		}
		return true
	},
	some: function(b, c) {
		for (var a in this) {
			if (this.hasOwnProperty(a) && b.call(c, this[a], a)) {
				return true
			}
		}
		return false
	},
	getKeys: function() {
		var a = [];
		Hash.each(this, function(c, b) {
			a.push(b)
		});
		return a
	},
	getValues: function() {
		var a = [];
		Hash.each(this, function(b) {
			a.push(b)
		});
		return a
	},
	toQueryString: function(a) {
		var b = [];
		Hash.each(this, function(g, f) {
			if (a) {
				f = a + "[" + f + "]"
			}
			var d;
			switch ($type(g)) {
			case "object":
				d = Hash.toQueryString(g, f);
				break;
			case "array":
				var c = {};
				g.each(function(k, h) {
					c[h] = k
				});
				d = Hash.toQueryString(c, f);
				break;
			default:
				d = f + "=" + encodeURIComponent(g)
			}
			if (g != undefined) {
				b.push(d)
			}
		});
		return b.join("&")
	}
});
Hash.alias({
	keyOf: "indexOf",
	hasValue: "contains"
});
//*************
var fine8_fmt = {
	defFmt: {
		"float": "{'type':'number','format':'0.00','style':''}",
		RMB: "{'type':'number','format':'0.00 RMB','style':''}",
		USD: "{'type':'number','format':'$ 0.00','style':''}"
	},
	convertText: function(d, a, b) {
		var c = {};
		var g = "";
		if (!$defined(a)) {
			a = ""
		}
		if (typeof(d) == "object") {
			c.value = a;
			c.realvalue = a;
			c.style = b || "";
			g = d.get("format");
			if (!$chk(g) || !$defined(g)) {
				return c
			}
			if (a == "") {
				var h = JSON.decode(g)["default"];
				if ($defined(h)) {
					c.value = h;
					c.realvalue = h
				} else {
					return c
				}
			}
		} else {
			if (typeof(d) == "string") {
				c.value = d;
				c.realvalue = d;
				g = a
			}
		}
		if (fine8_fmt.defFmt[g]) {
			g = fine8_fmt.defFmt[g]
		}
		try {
			$extend(c, JSON.decode(g))
		} catch (f) {}
		return this.builderText(c)
	},
	formatText: function(d, a, b, g) {
		var c = {};
		if (typeof(d) == "object") {
			c.value = a;
			c.realvalue = a;
			c.style = b || "";
			if (a == "") {
				var h = JSON.decode(g)["default"];
				return $defined(h) ? {
					value: h
				} : c
			}
		} else {
			if (typeof(d) == "string") {
				c.value = d;
				c.realvalue = d;
				g = a
			}
		}
		if (fine8_fmt.defFmt[g]) {
			g = fine8_fmt.defFmt[g]
		}
		try {
			$extend(c, JSON.decode(g))
		} catch (f) {}
		return this.builderText(c)
	},
	builderItem: function(a) {},
	aptitude: function(a) {},
	builderText: function(a) {
		if (a) {
			if (a.func) {
				var b = fine8_getFunc(a.func)[0];
				a.func = b
			}
			if (this[a.type]) {
				$extend(a, this[a.type].run(a));
				if (a.func) {
					a.func.run(a)
				}
			}
			return a
		} else {
			return {
				value: "",
				style: ""
			}
		}
	},
	routine: function(a) {},
	datePatterns: ["Y-m-d H:i:s.u", "Y-m-d H:i:s", "Y-m-d", "y-m-d", "m/d/y", "Y/m/d", "y/m/d", "Ymd", "ymd"],
	date: function(a) {
		var c = "";
		var d;
		if (!$chk(a.format)) {
			a.format = Date.patterns.ISO8601Long
		} else {
			if (a.value == "now") {
				d = new Date();
				c = d.dateFormat(a.format)
			} else {
				if (!$chk(a.analysisFormat)) {
					for (var b = 0; b < fine8_fmt.datePatterns.length; b++) {
						d = Date.parseDate(a.value, fine8_fmt.datePatterns[b]);
						if (d) {
							break
						}
					}
				} else {
					d = Date.parseDate(a.value, a.analysisFormat)
				}
				if ($chk(d)) {
					c = d.dateFormat(a.format)
				} else {
					c = a.value
				}
			}
		}
		$extend(a, {
			value: c,
			obj: d
		});
		return a
	},
	number: function(a) {
		var c = a.value;
		if (!$chk(c)) {
			c = 0
		}
		var b = (c / 1).numberFormat(a.format);
		b == Number.prototype.NaNstring ? a.value = (0 / 1).numberFormat(a.format) : a.value = b;
		return a
	},
	money: function(a) {
		AlertWrong(JSON.encode(a))
	},
	percent: function(d) {
		var c = d.value + "";
		var b = c.split(".");
		if (b.length > 1) {
			c = "";
			if (b[0].substring(0, 1) != "0") {
				c += b[0]
			}
			if (b[1].length > 2) {
				c += b[1].substring(0, 2);
				c = c.toInt() + "." + b[1].substring(2)
			} else {
				if (b[1].length == 2) {
					c = (c + b[1].substring(0, 2)).toInt()
				} else {
					c = (c + (b[1] + "0")).toInt()
				}
			}
		} else {
			c += (c.toInt() == 0) ? "" : "00"
		}
		d.value = c + "%";
		return d
	},
	exceptive: function(a) {},
	customer: function(a) {},
	money_chi: function(b) {
		var a = b.value;
		if (a) {
			b.value = fine8_fmt_convertCurrency(a)
		}
		return b
	}
};

function fine8_fmt_convertCurrency(y) {
	y = ($type(y) == "string") ? y / 1 : y;
	var c = 99999999999.99;
	var C = "零";
	var G = "壹";
	var l = "贰";
	var m = "叁";
	var o = "肆";
	var I = "伍";
	var F = "陆";
	var B = "柒";
	var K = "捌";
	var D = "玖";
	var h = "拾";
	var r = "佰";
	var u = "仟";
	var g = "万";
	var k = "亿";
	var A = "";
	var x = "元";
	var f = "角";
	var v = "分";
	var z = "整";
	var b;
	var N;
	var w;
	var J;
	var L, q, t, s;
	var a;
	var H, E, M;
	var O, n;
	y = y.toString();
	if (y == "") {
		return y
	}
	if (y.match(/[^,.\d]/) != null) {
		AlertWrong("输入字符中有不合法字符，请输入数字。");
		return y
	}
	if ((y).match(/^((\d{1,3}(,\d{3})*(.((\d{3},)*\d{1,3}))?)|(\d+(.\d+)?))$/) == null) {
		AlertWrong("输入的格式不合法。");
		return y
	}
	y = y.replace(/,/g, "");
	y = y.replace(/^0+/, "");
	if (Number(y) > c) {
		AlertWrong("您输入的超过了最大值：" + c);
		return y
	}
	J = y.split(".");
	if (J.length > 1) {
		b = J[0];
		N = J[1];
		N = N.substr(0, 2)
	} else {
		b = J[0];
		N = ""
	}
	L = new Array(C, G, l, m, o, I, F, B, K, D);
	q = new Array("", h, r, u);
	t = new Array("", g, k);
	s = new Array(f, v);
	w = "";
	if (Number(b) > 0) {
		a = 0;
		for (H = 0; H < b.length; H++) {
			E = b.length - H - 1;
			M = b.substr(H, 1);
			O = E / 4;
			n = E % 4;
			if (M == "0") {
				a++
			} else {
				if (a > 0) {
					w += L[0]
				}
				a = 0;
				w += L[Number(M)] + q[n]
			}
			if (n == 0 && a < 4) {
				w += t[O]
			}
		}
		w += x
	}
	if (N != "" && N != "00") {
		for (H = 0; H < N.length; H++) {
			M = N.substr(H, 1);
			if (M != "0") {
				w += L[Number(M)] + s[H]
			} else {
				w += L[Number(M)]
			}
		}
	} else {
		N = ""
	}
	if (w == "") {
		w = C + x
	}
	if (N == "") {
		w += z
	}
	w = A + w;
	return w
}

function _fine8IsScientific(a) {
	var b = String(a);
	if ((b.indexOf("E") != -1) || (b.indexOf("e") != -1)) {
		return true
	} else {
		return false
	}
}
function accAdd(f, d) {
	if (_fine8IsScientific(f) || _fine8IsScientific(d)) {
		return f + d
	}
	if (f == null) {
		f = 0
	}
	if (d == null) {
		d = 0
	}
	var c, b, a;
	try {
		c = f.toString().split(".")[1].length
	} catch (g) {
		c = 0
	}
	try {
		b = d.toString().split(".")[1].length
	} catch (g) {
		b = 0
	}
	a = Math.pow(10, Math.max(c, b));
	return (f.multiple(a) + d.multiple(a)) / a
}
Number.prototype.accAdd = function(a) {
	return parseFloat(accAdd(a, this))
};
String.prototype.accAdd = function(a) {
	return accAdd(a, this)
};

function accSubtr(f, d) {
	if (_fine8IsScientific(f) || _fine8IsScientific(d)) {
		return f - d
	}
	if (f == null) {
		f = 0
	}
	if (d == null) {
		d = 0
	}
	var c, b, a, h;
	try {
		c = f.toString().split(".")[1].length
	} catch (g) {
		c = 0
	}
	try {
		b = d.toString().split(".")[1].length
	} catch (g) {
		b = 0
	}
	a = Math.pow(10, Math.max(c, b));
	h = (c >= b) ? c : b;
	return ((f.multiple(a) - d.multiple(a)) / a).round(h)
}
Number.prototype.subtract = function(a) {
	return parseFloat(accSubtr(this, a))
};
String.prototype.subtract = function(a) {
	return accSubtr(this, a)
};

function accMul(k, g) {
	if (_fine8IsScientific(k) || _fine8IsScientific(g)) {
		return k * g
	}
	if (k == null) {
		k = 0
	}
	if (g == null) {
		g = 0
	}
	var d = 0,
		l = k.toString(),
		h = g.toString();
	var f = l.split(".");
	d += f.length > 1 ? f[1].length : 0;
	var c = h.split(".");
	d += c.length > 1 ? c[1].length : 0;
	return Number(l.replace(".", "")) * Number(h.replace(".", "")) / Math.pow(10, d)
}
Number.prototype.multiple = function(a) {
	return parseFloat(accMul(a, this))
};
String.prototype.multiple = function(a) {
	return accMul(a, this)
};

function accDiv(arg1, arg2) {
	if (_fine8IsScientific(arg1) || _fine8IsScientific(arg2)) {
		return arg1 / arg2
	}
	if (arg1 == null) {
		arg1 = 0
	}
	if (arg2 == null) {
		arg2 = 0
	}
	var t1 = 0,
		t2 = 0,
		r1, r2;
	try {
		t1 = arg1.toString().split(".")[1].length
	} catch (e) {}
	try {
		t2 = arg2.toString().split(".")[1].length
	} catch (e) {}
	with(Math) {
		r1 = Number(arg1.toString().replace(".", ""));
		r2 = Number(arg2.toString().replace(".", ""));
		return (r1 / r2) * pow(10, t2 - t1)
	}
}
Number.prototype.divide = function(a) {
	return parseFloat(accDiv(this, a))
};
String.prototype.divide = function(a) {
	return accDiv(this, a)
};
function round(a, c) {
	var b = 1;
	for (; c > 0; b *= 10, c--) {}
	for (; c < 0; b /= 10, c++) {}
	return Math.round(a.multiple(b)) / b
}
Number.prototype.round = function(a) {
	return parseFloat(round(this, a))
};
String.prototype.round = function(a) {
	return round(this, a)
};
Number.formatFunctions = {
	count: 0
};
String.formatFunctions = {
	count: 0
};
Number.prototype.NaNstring = "NaN";
Number.prototype.posInfinity = "Infinity";
Number.prototype.negInfinity = "-Infinity";
Number.prototype.numberFormat = function(b, a) {
	if (isNaN(this)) {
		return Number.prototype.NaNstring
	} else {
		if (this == +Infinity) {
			return Number.prototype.posInfinity
		} else {
			if (this == -Infinity) {
				return Number.prototype.negInfinity
			} else {
				if (Number.formatFunctions[b] == null) {
					Number.createNewFormat(b)
				}
			}
		}
	}
	return this[Number.formatFunctions[b]](a)
};
Number.createNewFormat = function(format) {
	var funcName = "format" + Number.formatFunctions.count++;
	Number.formatFunctions[format] = funcName;
	var code = "Number.prototype." + funcName + " = function(context){\n";
	var formats = format.split(";");
	switch (formats.length) {
	case 1:
		code += Number.createTerminalFormat(format);
		break;
	case 2:
		code += 'return (this < 0) ? this.numberFormat("' + _escape(formats[1]) + '", 1) : this.numberFormat("' + _escape(formats[0]) + '", 2);';
		break;
	case 3:
		code += 'return (this < 0) ? this.numberFormat("' + _escape(formats[1]) + '", 1) : ((this == 0) ? this.numberFormat("' + _escape(formats[2]) + '", 2) : this.numberFormat("' + _escape(formats[0]) + '", 3));';
		break;
	default:
		code += "throw 'Too many semicolons in format string';";
		break
	}
	eval(code + "}")
};
Number.createTerminalFormat = function(l) {
	if (l.length > 0 && l.search(/[0#?]/) == -1) {
		return "return '" + _escape(l) + "';\n"
	}
	var a = "var val = (context == null) ? new Number(this) : Math.abs(this);\n";
	var g = false;
	var f = l;
	var h = "";
	var n = 0;
	var o = 0;
	var b = 0;
	var k = false;
	var c = "";
	d = l.match(/\..*(e)([+-]?)(0+)/i);
	if (d) {
		c = d[1];
		k = (d[2] == "+");
		b = d[3].length;
		l = l.replace(/(e)([+-]?)(0+)/i, "")
	}
	var d = l.match(/^([^.]*)\.(.*)$/);
	if (d) {
		f = d[1].replace(/\./g, "");
		h = d[2].replace(/\./g, "")
	}
	if (l.indexOf("%") >= 0) {
		a += "val *= 100;\n"
	}
	d = f.match(/(,+)(?:$|[^0#?,])/);
	if (d) {
		a += "val /= " + Math.pow(1000, d[1].length) + "\n;"
	}
	if (f.search(/[0#?],[0#?]/) >= 0) {
		g = true
	}
	if ((d) || g) {
		f = f.replace(/,/g, "")
	}
	d = f.match(/0[0#?]*/);
	if (d) {
		n = d[0].length
	}
	d = h.match(/[0#?]*/);
	if (d) {
		o = d[0].length
	}
	if (b > 0) {
		a += "var sci = Number.toScientific(val," + n + ", " + o + ", " + b + ", " + k + ");\nvar arr = [sci.l, sci.r];\n"
	} else {
		if (l.indexOf(".") < 0) {
			a += "val = (val > 0&&val.toString().indexOf('.')!=-1&&val.toString().split('.')[1][0]<=4) ? Math.floor(val) : Math.ceil(val);\n"
		}
		a += "var arr = val.round(" + o + ").toFixed(" + o + ").split('.');\n";
		a += "arr[0] = (val < 0 ? '-' : '') + _leftPad((val < 0 ? arr[0].substring(1) : arr[0]), " + n + ", '0');\n"
	}
	if (g) {
		a += "arr[0] = Number.addSeparators(arr[0]);\n"
	}
	a += "arr[0] = Number.injectIntoFormat(arr[0].reverse(), '" + _escape(f.reverse()) + "', true).reverse();\n";
	if (o > 0) {
		a += "arr[1] = Number.injectIntoFormat(arr[1], '" + _escape(h) + "', false);\n"
	}
	if (b > 0) {
		a += "arr[1] = arr[1].replace(/(\\d{" + o + "})/, '$1" + c + "' + sci.s);\n"
	}
	return a + "return arr.join('.');\n"
};
Number.toScientific = function(c, h, k, b, d) {
	var l = {
		l: "",
		r: "",
		s: ""
	};
	var f = "";
	var g = Math.abs(c).toFixed(h + k + 1).trim("0");
	var a = Math.round(new Number(g.replace(".", "").replace(new RegExp("(\\d{" + (h + k) + "})(.*)"), "$1.$2"))).toFixed(0);
	if (a.length >= h) {
		a = a.substring(0, h) + "." + a.substring(h)
	} else {
		a += "."
	}
	l.s = (g.indexOf(".") - g.search(/[1-9]/)) - a.indexOf(".");
	if (l.s < 0) {
		l.s++
	}
	l.l = (c < 0 ? "-" : "") + _leftPad(a.substring(0, a.indexOf(".")), h, "0");
	l.r = a.substring(a.indexOf(".") + 1);
	if (l.s < 0) {
		f = "-"
	} else {
		if (d) {
			f = "+"
		}
	}
	l.s = f + _leftPad(Math.abs(l.s).toFixed(0), b, "0");
	return l
};
Number.injectIntoFormat = function(h, g, b) {
	var d = 0;
	var c = 0;
	var a = "";
	var f = h.charAt(h.length - 1) == "-";
	if (f) {
		h = h.substring(0, h.length - 1)
	}
	while (d < g.length && c < h.length && g.substring(d).search(/[0#?]/) >= 0) {
		if (g.charAt(d).match(/[0#?]/)) {
			if (h.charAt(c) != "-") {
				a += h.charAt(c)
			} else {
				a += "0"
			}
			c++
		} else {
			a += g.charAt(d)
		}++d
	}
	if (f && c == h.length) {
		a += "-"
	}
	if (c < h.length) {
		if (b) {
			a += h.substring(c)
		}
		if (f) {
			a += "-"
		}
	}
	if (d < g.length) {
		a += g.substring(d)
	}
	return a.replace(/#/g, "").replace(/\?/g, " ")
};
Number.addSeparators = function(a) {
	return a.reverse().replace(/(\d{3})/g, "$1,").reverse().replace(/^(-)?,/, "$1")
};
Date.parseFunctions = {
	count: 0
};
Date.parseRegexes = [];
Date.formatFunctions = {
	count: 0
};
Date.patterns = {
	ISO8601Long: "Y-m-d H:i:s",
	ISO8601Short: "Y-m-d",
	ShortDate: "n/j/Y",
	LongDate: "l, F d, Y",
	FullDateTime: "l, F d, Y g:i:s A",
	MonthDay: "F d",
	ShortTime: "g:i A",
	LongTime: "g:i:s A",
	SortableDateTime: "Y-m-d\\TH:i:s",
	UniversalSortableDateTime: "Y-m-d H:i:sO",
	YearMonth: "F, Y"
};
Date.prototype.dateFormat = function(b) {
	if (Date.formatFunctions[b] == null) {
		Date.createNewFormat(b)
	}
	var a = Date.formatFunctions[b];
	return this[a]()
};
Date.prototype.format = Date.prototype.dateFormat;
Date.createNewFormat = function(format) {
	var funcName = "format" + Date.formatFunctions.count++;
	Date.formatFunctions[format] = funcName;
	var code = "Date.prototype." + funcName + " = function(){return ";
	var special = false;
	var ch = "";
	for (var i = 0; i < format.length; ++i) {
		ch = format.charAt(i);
		if (!special && ch == "\\") {
			special = true
		} else {
			if (special) {
				special = false;
				code += "'" + _escape(ch) + "' + "
			} else {
				code += Date.getFormatCode(ch)
			}
		}
	}
	eval(code.substring(0, code.length - 3) + ";}")
};
Date.getFormatCode = function(a) {
	switch (a) {
	case "d":
		return "_leftPad(this.getDate(), 2, '0') + ";
	case "D":
		return "Date.dayNames[this.getDay()].substring(0, 3) + ";
	case "j":
		return "this.getDate() + ";
	case "l":
		return "Date.dayNames[this.getDay()] + ";
	case "S":
		return "this.getSuffix() + ";
	case "w":
		return "this.getDay() + ";
	case "z":
		return "this.getDayOfYear() + ";
	case "W":
		return "this.getWeekOfYear() + ";
	case "F":
		return "Date.monthNames[this.getMonth()] + ";
	case "m":
		return "_leftPad(this.getMonth() + 1, 2, '0') + ";
	case "M":
		return "Date.monthNames[this.getMonth()].substring(0, 3) + ";
	case "n":
		return "(this.getMonth() + 1) + ";
	case "t":
		return "this.getDaysInMonth() + ";
	case "L":
		return "(this.isLeapYear() ? 1 : 0) + ";
	case "Y":
		return "this.getFullYear() + ";
	case "y":
		return "('' + this.getFullYear()).substring(2, 4) + ";
	case "a":
		return "(this.getHours() < 12 ? 'am' : 'pm') + ";
	case "A":
		return "(this.getHours() < 12 ? 'AM' : 'PM') + ";
	case "g":
		return "((this.getHours() % 12) ? this.getHours() % 12 : 12) + ";
	case "G":
		return "this.getHours() + ";
	case "h":
		return "_leftPad((this.getHours() % 12) ? this.getHours() % 12 : 12, 2, '0') + ";
	case "H":
		return "_leftPad(this.getHours(), 2, '0') + ";
	case "i":
		return "_leftPad(this.getMinutes(), 2, '0') + ";
	case "s":
		return "_leftPad(this.getSeconds(), 2, '0') + ";
	case "u":
		return "_leftPad(this.getMilliseconds(), 4, '0') + ";
	case "O":
		return "this.getGMTOffset() + ";
	case "T":
		return "this.getTimezone() + ";
	case "Z":
		return "(this.getTimezoneOffset() * -60) + ";
	default:
		return "'" + _escape(a) + "' + "
	}
};
Date.parseDate = function(a, c) {
	if (Date.parseFunctions[c] == null) {
		Date.createParser(c)
	}
	var b = Date.parseFunctions[c];
	return Date[b](a)
};
Date.createParser = function(format) {
	var funcName = "parse" + Date.parseFunctions.count++;
	var regexNum = Date.parseRegexes.length;
	var currentGroup = 1;
	Date.parseFunctions[format] = funcName;
	var code = "Date." + funcName + " = function(input){\nvar y = -1, m = -1, d = -1, h = -1, i = -1, s = -1, o, z, v;\nvar d = new Date();\ny = d.getFullYear();\nm = d.getMonth();\nd = d.getDate();\nvar results = input.match(Date.parseRegexes[" + regexNum + "]);\nif (results && results.length > 0) {";
	var regex = "";
	var special = false;
	var ch = "";
	for (var i = 0; i < format.length; ++i) {
		ch = format.charAt(i);
		if (!special && ch == "\\") {
			special = true
		} else {
			if (special) {
				special = false;
				regex += _escape(ch)
			} else {
				var obj = Date.formatCodeToRegex(ch, currentGroup);
				currentGroup += obj.g;
				regex += obj.s;
				if (obj.g && obj.c) {
					code += obj.c
				}
			}
		}
	}
	code += "if (y >= 0 && m >= 0 && d > 0 && h >= 0 && i >= 0 && s >= 0)\n{v = new Date(y, m, d, h, i, s);}\nelse if (y >= 0 && m >= 0 && d > 0 && h >= 0 && i >= 0)\n{v = new Date(y, m, d, h, i);}\nelse if (y >= 0 && m >= 0 && d > 0 && h >= 0)\n{v = new Date(y, m, d, h);}\nelse if (y >= 0 && m >= 0 && d > 0)\n{v = new Date(y, m, d);}\nelse if (y >= 0 && m >= 0)\n{v = new Date(y, m);}\nelse if (y >= 0)\n{v = new Date(y);}\n}return (v && (z || o))?\n    ((z)? v.add(Date.SECOND, (v.getTimezoneOffset() * 60) + (z*1)) :\n        v.add(Date.HOUR, (v.getGMTOffset() / 100) + (o / -100))) : v\n;}";
	Date.parseRegexes[regexNum] = new RegExp("^" + regex + "$", "i");
	eval(code)
};
Date.formatCodeToRegex = function(b, a) {
	switch (b) {
	case "D":
		return {
			g: 0,
			c: null,
			s: "(?:Sun|Mon|Tue|Wed|Thu|Fri|Sat)"
		};
	case "j":
		return {
			g: 1,
			c: "d = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{1,2})"
		};
	case "d":
		return {
			g: 1,
			c: "d = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{2})"
		};
	case "l":
		return {
			g: 0,
			c: null,
			s: "(?:" + Date.dayNames.join("|") + ")"
		};
	case "S":
		return {
			g: 0,
			c: null,
			s: "(?:st|nd|rd|th)"
		};
	case "w":
		return {
			g: 0,
			c: null,
			s: "\\d"
		};
	case "z":
		return {
			g: 0,
			c: null,
			s: "(?:\\d{1,3})"
		};
	case "W":
		return {
			g: 0,
			c: null,
			s: "(?:\\d{2})"
		};
	case "F":
		return {
			g: 1,
			c: "m = parseInt(Date.monthNumbers[results[" + a + "].substring(0, 1).toUpperCase() + results[" + a + "].substring(1, 3).toLowerCase()], 10);\n",
			s: "(" + Date.monthNames.join("|") + ")"
		};
	case "M":
		return {
			g: 1,
			c: "m = parseInt(Date.monthNumbers[results[" + a + "].substring(0, 1).toUpperCase() + results[" + a + "].substring(1, 3).toLowerCase()], 10);\n",
			s: "(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)"
		};
	case "n":
		return {
			g: 1,
			c: "m = parseInt(results[" + a + "], 10) - 1;\n",
			s: "(\\d{1,2})"
		};
	case "m":
		return {
			g: 1,
			c: "m = parseInt(results[" + a + "], 10) - 1;\n",
			s: "(\\d{2})"
		};
	case "t":
		return {
			g: 0,
			c: null,
			s: "\\d{1,2}"
		};
	case "L":
		return {
			g: 0,
			c: null,
			s: "(?:1|0)"
		};
	case "Y":
		return {
			g: 1,
			c: "y = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{4})"
		};
	case "y":
		return {
			g: 1,
			c: "var ty = parseInt(results[" + a + "], 10);\ny = ty > Date.y2kYear ? 1900 + ty : 2000 + ty;\n",
			s: "(\\d{1,2})"
		};
	case "a":
		return {
			g: 1,
			c: "if (results[" + a + "] == 'am') {\nif (h == 12) { h = 0; }\n} else { if (h < 12) { h += 12; }}",
			s: "(am|pm)"
		};
	case "A":
		return {
			g: 1,
			c: "if (results[" + a + "] == 'AM') {\nif (h == 12) { h = 0; }\n} else { if (h < 12) { h += 12; }}",
			s: "(AM|PM)"
		};
	case "g":
	case "G":
		return {
			g: 1,
			c: "h = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{1,2})"
		};
	case "h":
	case "H":
		return {
			g: 1,
			c: "h = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{2})"
		};
	case "i":
		return {
			g: 1,
			c: "i = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{2})"
		};
	case "s":
		return {
			g: 1,
			c: "s = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{2})"
		};
	case "u":
		return {
			g: 1,
			c: "u = parseInt(results[" + a + "], 10);\n",
			s: "(\\d{4})"
		};
	case "O":
		return {
			g: 1,
			c: ["o = results[", a, "];\n", "var sn = o.substring(0,1);\n", "var hr = o.substring(1,3)*1 + Math.floor(o.substring(3,5) / 60);\n", "var mn = o.substring(3,5) % 60;\n", "o = ((-12 <= (hr*60 + mn)/60) && ((hr*60 + mn)/60 <= 14))?\n", "    (sn + _leftPad(hr, 2, 0) + _leftPad(mn, 2, 0)) : null;\n"].join(""),
			s: "([+-]\\d{4})"
		};
	case "T":
		return {
			g: 0,
			c: null,
			s: "[A-Z]{1,4}"
		};
	case "Z":
		return {
			g: 1,
			c: "z = results[" + a + "];\nz = (-43200 <= z*1 && z*1 <= 50400)? z : null;\n",
			s: "([+-]?\\d{1,5})"
		};
	default:
		return {
			g: 0,
			c: null,
			s: _escape(b)
		}
	}
};
Date.prototype.getTimezone = function() {
	return this.toString().replace(/^.*? ([A-Z]{1,4})[\-+][0-9]{4} .*$/, "$1")
};
Date.prototype.getGMTOffset = function() {
	return (this.getTimezoneOffset() > 0 ? "-" : "+") + _leftPad(Math.abs(Math.floor(this.getTimezoneOffset() / 60)), 2, "0") + _leftPad(this.getTimezoneOffset() % 60, 2, "0")
};
Date.prototype.getDayOfYear = function() {
	var a = 0;
	Date.daysInMonth[1] = this.isLeapYear() ? 29 : 28;
	for (var b = 0; b < this.getMonth(); ++b) {
		a += Date.daysInMonth[b]
	}
	return a + this.getDate() - 1
};
Date.prototype.getWeekOfYear = function() {
	var b = this.getDayOfYear() + (4 - this.getDay());
	var a = new Date(this.getFullYear(), 0, 1);
	var c = (7 - a.getDay() + 4);
	return _leftPad(((b - c) / 7) + 1, 2, "0")
};
Date.prototype.isLeapYear = function() {
	var a = this.getFullYear();
	return ((a & 3) == 0 && (a % 100 || (a % 400 == 0 && a)))
};
Date.prototype.getFirstDayOfMonth = function() {
	var a = (this.getDay() - (this.getDate() - 1)) % 7;
	return (a < 0) ? (a + 7) : a
};
Date.prototype.getLastDayOfMonth = function() {
	var a = (this.getDay() + (Date.daysInMonth[this.getMonth()] - this.getDate())) % 7;
	return (a < 0) ? (a + 7) : a
};
Date.prototype.getFirstDateOfMonth = function() {
	return new Date(this.getFullYear(), this.getMonth(), 1)
};
Date.prototype.getLastDateOfMonth = function() {
	return new Date(this.getFullYear(), this.getMonth(), this.getDaysInMonth())
};
Date.prototype.getDaysInMonth = function() {
	Date.daysInMonth[1] = this.isLeapYear() ? 29 : 28;
	return Date.daysInMonth[this.getMonth()]
};
Date.prototype.getSuffix = function() {
	switch (this.getDate()) {
	case 1:
	case 21:
	case 31:
		return "st";
	case 2:
	case 22:
		return "nd";
	case 3:
	case 23:
		return "rd";
	default:
		return "th"
	}
};
Date.daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
Date.monthNames = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
Date.dayNames = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
Date.y2kYear = 50;
Date.monthNumbers = {
	Jan: 0,
	Feb: 1,
	Mar: 2,
	Apr: 3,
	May: 4,
	Jun: 5,
	Jul: 6,
	Aug: 7,
	Sep: 8,
	Oct: 9,
	Nov: 10,
	Dec: 11
};
Date.prototype.clone = function() {
	return new Date(this.getTime())
};
Date.prototype.clearTime = function(a) {
	if (a) {
		return this.clone().clearTime()
	}
	this.setHours(0);
	this.setMinutes(0);
	this.setSeconds(0);
	this.setMilliseconds(0);
	return this
};
Date.MILLI = "ms";
Date.SECOND = "s";
Date.MINUTE = "mi";
Date.HOUR = "h";
Date.DAY = "d";
Date.MONTH = "mo";
Date.YEAR = "y";
Date.prototype.add = function(b, c) {
	var f = this.clone();
	if (!b || c === 0) {
		return f
	}
	switch (b.toLowerCase()) {
	case Date.MILLI:
		f.setMilliseconds(this.getMilliseconds() + c);
		break;
	case Date.SECOND:
		f.setSeconds(this.getSeconds() + c);
		break;
	case Date.MINUTE:
		f.setMinutes(this.getMinutes() + c);
		break;
	case Date.HOUR:
		f.setHours(this.getHours() + c);
		break;
	case Date.DAY:
		f.setDate(this.getDate() + c);
		break;
	case Date.MONTH:
		var a = this.getDate();
		if (a > 28) {
			a = Math.min(a, this.getFirstDateOfMonth().add("mo", c).getLastDateOfMonth().getDate())
		}
		f.setDate(a);
		f.setMonth(this.getMonth() + c);
		break;
	case Date.YEAR:
		f.setFullYear(this.getFullYear() + c);
		break
	}
	return f
};
Date.prototype.between = function(c, a) {
	var b = this.getTime();
	return b >= c.getTime() && b <= a.getTime()
};
_leftPad = function(d, b, c) {
	var a = new String(d);
	if (c == null) {
		c = " "
	}
	while (a.length < b) {
		a = c + a
	}
	return a
};
_escape = function(a) {
	return a.replace(/('|\\)/g, "\\$1")
};
String.prototype.reverse = function() {
	var b = "";
	for (var a = this.length; a > 0; --a) {
		b += this.charAt(a - 1)
	}
	return b
};
xyposition = function(c, b, a) {
	xposition(c, b, a);
	yposition(c, b)
};
xposition = function(g, d, a) {
	var h;
	var c = d.measure(function() {
		return this.getSize()
	});
	if (!$defined(a)) {
		h = g._getPosition().y - $(document.body).getScroll().y + g.getHeight() + c.y + 20
	} else {
		h = g._getPosition().y - $(document.body).getScroll().y - c.y - 5
	}
	var b = $(document.body).getHeight();
	if ((!$defined(a) && h > b) || ($defined(a) && h >= 0)) {
		var f = g._getPosition().y - c.y;
		if (f < 0) {
			d.setStyle("top", (g._getPosition().y + g.getHeight()))
		} else {
			d.setStyle("top", f)
		}
	} else {
		d.setStyle("top", (g._getPosition().y + g.getHeight()))
	}
};
yposition = function(c, b) {
	var d = c._getPosition().x - $(document.body).getScrollWidth() + b.getWidth();
	var a = $(document.body).getWidth();
	if (d > 0) {
		b.setStyle("left", (a - b.getWidth()))
	} else {
		b.setStyle("left", c._getPosition().x)
	}
};
$dateFmt = function(b, f, a) {
	if (!$defined(b)) {
		return
	}
	if (!$defined(b) && !$defined(f)) {
		return
	}
	var d = b.split(".");
	if (d.length <= 2) {
		if (!_fine8DF.isDate(d[0], "yyyy-MM-dd HH:mm:ss")) {
			return false
		}
	} else {
		return false
	}
	if (!$defined(a)) {
		a = f.get("dataformat")
	}
	if (!$defined(a)) {
		a = "yyyy-MM-dd HH:mm:ss"
	}
	var c;
	if (_fine8DF.isDate(b, a)) {
		c = b
	} else {
		c = _fine8DF.formatStringToString(b, "yyyy-MM-dd HH:mm:ss", a)
	}
	f.set("realvalue", b);
	f.set("value", c);
	f.set("text", c);
	return true
};
//********************************************************
/**
 * 动态添加js文件
 * @param jsPath
 * @param callback
 */
function addJsFile(jsPath, callback) {
	var es = document.getElementsByTagName('script');
	for (var i = 0; i < es.length; i++) {
		if (es[i]['src'] == jsPath) {//已经引用直接回调
			callback.apply();
			return false;
		}
	}
	var head = document.getElementsByTagName('head')[0];
	var script = document.createElement('script');
	script.type = 'text/javascript';
	script.onload = script.onreadystatechange = function () {
		if (!this.readyState || this.readyState === "loaded" || this.readyState === "complete") {//JS加载完成再回调
			callback.apply();
			script.onload = script.onreadystatechange = null;
		}
	};
	script.src = jsPath;
	head.appendChild(script);
}


function jsTrim(x) {
    return parseString(x).replace(/^\s+|\s+$/gm,'');
}

//判断数据是否有效
function parseString(data){
	if(data == "" || data == null || data == undefined || data == "null" || data == "[]")
	 return "";
	 if(data=="Y")
	  {return "有效";}
	else if(data=="N")
	  {return "无效";}
	  return data;
}
function getQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if (r != null) return unescape(r[2]);
	return null;
 }
function parseNumber(data)
{
	if(data == "" || data == null || data == undefined || data == "null" || data == "[]")
	 return "0.00";
	  return data;

}
 function toDecimal2(x) {
	var f = parseFloat(x);
	if (isNaN(f)) {
		return false;
	}
	var f = Math.round(x*100)/100;
	var s = f.toString();
	var rs = s.indexOf('.');
	if (rs < 0) {
		rs = s.length;
		s += '.';
	}
	while (s.length <= rs + 2) {
		s += '0';
	}
	return s;
}
//获取起止日期
function getrqq(ssny){
	if(ssny.length!=6){return ssny}
	var Oyear = ssny.substring(0,4);
	var Omonth = ssny.substring(4);
	return Oyear+"-"+Omonth+"-01";
}
function getrqz(ssny){
	if(ssny.length!=6){return ssny}
	var Oyear = ssny.substring(0,4);
	var Omonth = ssny.substring(4);
	var lastday=new Date(Oyear,Omonth,0);
	return lastday.getFullYear() + '-' + (lastday.getMonth() + 1) + '-' + lastday.getDate();
}
function isIntNum(val){
    var regPos = /^\d+$/; // 非负整数
    var regNeg = /^\-[1-9][0-9]*$/; // 负整数
    if(regPos.test(val)){// || regNeg.test(val)
        return true;
    }else{
        return false;
    }
}
function compare_time(a,b) {
var arr=a.split("-");
var starttime=new Date(arr[0],arr[1],arr[2]);
var starttimes=starttime.getTime();
var arrs=b.split("-");
var endtime=new Date(arrs[0],arrs[1],arrs[2]);
var endtimes=endtime.getTime();
if(starttimes>endtimes)//开始大于结束
{
return false;
}
else{
return true;
}
}
function IsDate(sm,mystring) {
var reg = /^(\d{4})-(\d{1,2})$/;
var str = mystring;
var arr = reg.exec(str);
if (str=="") return true;
if (!reg.test(str)&&RegExp.$2<=12){
return false;
}
return true;
}
function crtTimeFtt(val) {
    if (val != null) {
		    if(/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)){
	      	var Odate = (val.split(" ")[0]).split("-");
	      	return Odate[0]+"-"+(parseInt(Odate[1])+1)+"-"+Odate[2];
		}else
			{
		    var date = new Date(val);
			return date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
			}

        }
}

//字轨
function getpzPcZg(pzzlDm)
{
	for(var i=0;i<pzzldmarray.length;i++)
	{
		if(pzzldmarray[i].pzzlDm==pzzlDm)
		{
			return pzzldmarray[i].code;
		}
	}
	return pzzlDm;
}
function getlist(list,tag)
{
	for(var i=0;i<list.length;i++)
	{
		if(list[i].key==tag)
		{
			return list[i].list;
		}
	}
	return null;
}
//身份证照类型
function getsfzzlx(sfzzlx)
{
	if(sfzzlx=="") return sfzzlx;
	for(var i=0;i<zjlx.length;i++)
	{
		if(zjlx[i].SFZJLX_DM==sfzzlx)
		{
			return zjlx[i].SFZJLXMC;
		}
	}
	return sfzzlx;
}
//登记注册类型
function getdjzclx(djzclx)
{
	if(djzclx=="") return djzclx;
	if(jsTrim(DJZCLX_DM)==djzclx) return DJZCLXMC;
	return djzclx;
}
//纳税人分类
function getnsrfl(nsrfl)
{
	if(nsrfl=="") return nsrfl;
	for(var i=0;i<nsrlx.length;i++)
	{
		if(nsrlx[i].NSRLX_DM==nsrfl)
		{
			return nsrlx[i].NSRLXMC;
		}
	}
	return nsrfl;
}
//隶属关系
function getlsgx(lsgxr)
{
	if(lsgxr=="") return lsgxr;
	for(var i=0;i<lsgx.length;i++)
	{
		if(lsgx[i].DWLSGX_DM==lsgxr)
		{
			return lsgx[i].DWLSGXMC;
		}
	}
	return lsgxr;
}
//申报类型
function getsblx(lx)
{
	if(lx=="") return lx;
	for(var i=0;i<sblx.length;i++)
	{
		if(sblx[i].SBSX_DM_1==lx)
		{
			return sblx[i].SBSXMC_1;
		}
	}
	return lx;
}

//选取申报类型
function getsblx2(lx){
	var mykey=gt3.sbsx;//'11';
	if(lx=="") return lx;
	for(var i=0,l=lx.length;i<l;i++){
	　　for(var key in lx[i]){
				if(key==mykey){
					//alert(key+':'+lx[i][key]);
					return lx[i];
				}　　　　
			}
	}
	return null;
}
//手机号码
function getsjhm1(sjhm)
{
	if(sjhm=="") return PHONE;
	return sjhm;
}
//行业
function gethy(hy)
{
	if(HY_DM=="") return hy;
	if(jsTrim(HY_DM)==hy) return HYMC;
	//return hy;
	return HYMC;
}
//税务机关
function getswjg(swjglist,swjg)
{
	if(swjglist==null) return swjg;
	for(var i=0;i<swjglist.length;i++)
	{
		if(jsTrim(swjglist[i].SWJG_DM)==swjg)
		{
			return swjglist[i].SWJGMC;
		}
	}
	return swjg;
}
//征收项目
function getzsxm(zsxmlist,zsxm)
{
	if(zsxmlist==null) return zsxm;
	for(var i=0;i<zsxmlist.length;i++)
	{
		if(jsTrim(zsxmlist[i].ZSXM_DM)==zsxm)
		{
			return zsxmlist[i].ZSXMMC;
		}
	}
	return zsxm;
}
//征收品目
function getzspm(zspmlist,zspm)
{
	if(zspmlist==null) return zspm;
	for(var i=0;i<zspmlist.length;i++)
	{
		if(jsTrim(zspmlist[i].ZSPM_DM)==zspm)
		{
			return zspmlist[i].ZSPMMC;
		}
	}
	return zspm;
}
//征收品目
function getzspmsl(zspmlist,zspm)
{
	if(zspmlist==null) return 0.00;
	for(var i=0;i<zspmlist.length;i++)
	{
		if(jsTrim(zspmlist[i].ZSPM_DM)==zspm)
		{
			return zspmlist[i].SL_1;
		}
	}
	return 0.00;
}
//征收子目
function getzszm(zszmlist,zszm)
{
	if(zszmlist==null) return zszm;
	for(var i=0;i<zszmlist.length;i++)
	{
		if(jsTrim(zszmlist[i].ZSZM_DM)==zszm)
		{
			return zszmlist[i].ZSZMMC;
		}
	}
	return zszm;
}
function tips(content)
{
	var html = '<li   class="mui-table-view-cell mui-media">';
	html += '<div class="mui-card">';
	html += '<div class="mui-card-content">';
	html += '<div class="mui-card-content-inner">';
	html += '<p style="color: red;">'+content+'</span></p>';
	html += '</div></div>';
	html += '</div></div></li>';
	return html;
}
function strtrip(str)
{
	var s=str.lastIndexOf("没有查询到该纳税人");
	if(s>=0)
	{
		return str.substring(s);
	}
	return str;
}
function tishiwq(len){
	if(fdczqqx=="1")
	{
		var content="检查到往期未申报数据"+len+"条，请到办税大厅处理。"
		var btnArray = ['确定'];
		mui.confirm(content, '提示', btnArray, function(e) {

		});
		mui.toast("检查到往期未申报数据"+len+"条，请到办税大厅处理。");
		$("#len").html(len);
		$("#TaxHand").css("display","none");
		$("#Tax_handle p").css("display","block");
	}
}
function zq_tips(tips){
	var content="房产税、土地使用税申报期限为本年"+tips;
	$("#lentip").html("");
	$("#taxzq").html(content);
	$("#TaxHand").css("display","none");
	$("#Tax_handle p").css("display","block");
}
//进度图效果
function loadingShow(des) {
	$('body').loading({
		loadingWidth: 120,
		title: '',
		name: 'subtip',
		discription: des,
		direction: 'column',
		type: 'origin',
		// originBg:'#71EA71',
		originDivWidth: 40,
		originDivHeight: 40,
		originWidth: 6,
		originHeight: 6,
		smallLoading: false,
		loadingMaskBg: 'rgba(0,0,0,0.2)'
	});


}
function loadingHidden()
{
	removeLoading('subtip');
}
//申报类型
function  createSBSX(id,arr,sel_dm)
{
	var html="";
	html += '<select id="'+id+'" name="'+id+'" style="">';
	for(var p in arr){
	 	 if(sel_dm==p){
		 html+="<option value='"+p+"' selected='selected'>"+p+"|"+arr[p]+"</option>";
	 	 }
		 else
		 {
		 html+="<option value='"+p+"' selected='selected'>"+p+"|"+arr[p]+"</option>";
		 }
	}
	html += '</select>';
	return html;
}
//createselect("nsrfltxt",nsrlx,"NSRLX_DM","NSRLXMC",mx.nsrlx);
function createselect(id,arr,dm,mc,sel_dm)
{

	var html="";
	html += '<select id="'+id+'" name="'+id+'" style="">';
	for(var p in arr){
		var k=arr[p];
		//console.log(k);
		//console.log(sel_dm);
		if(p==0&& (sel_dm==null||sel_dm==""||sel_dm==undefined)){
			html += '<option selected="selected" value="'+k[dm]+'">'+k[dm]+'|'+k[mc]+'</option>';
		}
		else if(sel_dm!="" && k[dm]==sel_dm)
		{
			html += '<option selected="selected" value="'+k[dm]+'">'+k[dm]+'|'+k[mc]+'</option>';
		}
		else{
			html += '<option value="'+k[dm]+'">'+k[dm]+'|'+k[mc]+'</option>';
		}

	}
	html += '</select>';
	return html;
}

//分组
function groupdata(alldata,groupkey)//syuuid
{
	var map={};
	var dest=[];
	for(var i=0;i<alldata.length;i++)
	{
		var ai=alldata[i];
		if(!map[ai[groupkey]])
		{
			dest.push({
					  groupkey:ai[groupkey],
					  data:[ai]
					  });
			map[ai[groupkey]]=ai;
		}
		else
		{
			for(var j=0;j<dest.length;j++)
			{
				var dj=dest[j];
				//console.log(dj.groupkey+"="+ai[groupkey]);
				if(dj.groupkey==ai[groupkey])
				{
					dj.data.push(ai);
					break;
				}
			}
		}
	}
	//console.log(dest);
	return dest;
}
//**************sb**********************
//企业申报头和受理人
function sbheadslr(gt3,rspdata){
	 var nsrInfo=rspdata.nsrInfo;
	 gt3.skssqq=rspdata.skssqq;
	 gt3.skssqz=rspdata.skssqz;
	 gt3.djxh=nsrInfo.djxh;
	 gt3.today=rspdata.sbrq;
	 gt3.zrrBz='N';
	//构建申报头和受理人信息 xzqhszDm
   gt3.nsrxxForm={"sbrq1":rspdata.sbrq,"xzqhszDm":nsrInfo.zcdxzqh,"sbsxDm1":gt3.sbsx,"hyDm":nsrInfo.hyDm,"pzxh":"","skssqq":gt3.skssqq,"zgswskfjDm":rspdata.zgswskfj_DM,"sbuuid":"","yzpzzlDm":"","skssqz":gt3.skssqz,"djxh":gt3.djxh,"jdxzDm":rspdata.jdxzDm};
   gt3.slxxForm={"dzdw":"","bz":"","slr":rspdata.slrxm,"dlrlxdh":rspdata.mobile,"jbr":"","swdlrjbr":"","blrysfzjlxDm":rspdata.zjlx,"slrq":rspdata.slrq,"swdlrmc":"","blrysfzjhm":rspdata.zjhm,"slswjg":rspdata.slswjgdm};
}
//自然人申报头和受理人
function zrrsbheadslr(zrrxxhead)
{
	// var zzrInfo=zrrxxhead.zrrxxlbvo;
	 gt3.skssqq=zrrxxhead.skssqq;
	gt3.skssqz=zrrxxhead.skssqz;
	gt3.djxh=zrrxxhead.zrrxxlbvo.djxh;
	gt3.today=zrrxxhead.sbrq;
	gt3.zrrBz='Y';
	//构建申报头和受理人信息 xzqhszDm
//gt3.zrrxxForm={"sbrq1":zrrxxhead.sbrq,"xzqhszDm":zrrxxhead.zcdxzqh,"sbsxDm1":gt3.sbsx,"hyDm":zrrxxhead.hyDm,"pzxh":"","skssqq":gt3.skssqq,"zgswskfjDm":rspdata.zgswskfj_DM,"sbuuid":"","yzpzzlDm":"","skssqz":gt3.skssqz,"djxh":gt3.djxh,"jdxzDm":zrrxxhead.jdxzDm};
gt3.slxxForm={"dzdw":"","bz":"","slr":zrrxxhead.slrxm,"dlrlxdh":zrrxxhead.mobile,"jbr":"","swdlrjbr":"","blrysfzjlxDm":zrrxxhead.zjlx,"slrq":zrrxxhead.slrq,"swdlrmc":"","blrysfzjhm":zrrxxhead.zjhm,"slswjg":zrrxxhead.slswjgdm};
}
//表头url参数
function sbheadurl(gt3)
{
	var nsrxxform=JSON.stringify(gt3.nsrxxForm);
	var slxxfrom=JSON.stringify(gt3.slxxForm);
	var sjgsdq=gt3.sbhead.sjgsdq;
	var nsrztDm=gt3.sbhead.nsrztDm;
    var param="nsrxxform="+encodeURIComponent(nsrxxform)+"&slxxfrom="+encodeURIComponent(slxxfrom)+"&sjgsdq="+sjgsdq+"&nsrztDm="+nsrztDm;
	return param;
}
//表头解析
function sbheadurldecode(gt3)
{
	var nsrxxform=decodeURIComponent(getQueryString("nsrxxform"));
	var slxxfrom=decodeURIComponent(getQueryString("slxxfrom"));

	gt3.nsrxxForm=JSON.parse(nsrxxform);
	gt3.slxxForm=JSON.parse(slxxfrom);
	gt3.sjgsdq=getQueryString("sjgsdq");
	gt3.nsrztDm=getQueryString("nsrztDm");
}

function fromYbSBJumpZskp(pzxh, ybtse, djxh, resData) {
	//跳转到缴款
	/*WSSB.pzxh = pzxh;
	WSSB.ybtse = ybtse;
	WSSB.djxh = djxh;
	WSSB.resData = resData;
	var submitXtcs = new Submit();
	submitXtcs.pushData("xtcsbm", "Z0000096Z02000031");
	submitXtcs.setCtrl("SBGyCtrl_getXtcsDzswj");
	submitXtcs.setFunction('onSuccess', 'afterGetTzfsXtcsForZskp');
	submitXtcs.submit();*/
}
//输出confirm信息框
function AlertWrong(str){
	mui.confirm(str, '提示', ['确认'], function(e) {
	}, 'div')
}

//输出toast信息框
function muialert(str){
	mui.toast(str);
}
//截取前后空格
function trimStr(str) {
	return str.replace(/(^\s*)|(\s*$)/g, "");
}
/**
 * 根据相应字符截取字符串
 *
 * @param {Object}
 *            dateStr
 * @param {Object}
 *            chars
 * @return {TypeName}
 */
function splitStrToChar(dateStr, splitChar) {
	return trimStr(dateStr).split(splitChar);
}
/**
 * 截取日期，以数组形式返回年月日
 *
 * @param {Object}
 *            dataStr
 */
var splitStr = function(dataStr) {
	// 截取前面年月日
	var dateStr = splitStrToChar(dataStr, " ")[0];
	// 分割字符
	var splitChar = dateStr.indexOf("-") != -1 ? "-" : "/";

	return splitStrToChar(dateStr, splitChar);
}
/**
 * 校验日期基本格式yyyy-mm-dd 当校验不通过时，若msg非空则弹出提示信息，否则直接返回false
 */
function checkDateBasic(inDate, msg) {
	if (inDate != "") {
		var pattern = /\d{4}-\d{1,2}-\d{1,2}( \d{2}:\d{2}:\d{2}){0,1}$/;
		if (pattern.exec(inDate) == null) {
			if (!(msg == undefined || msg == null)) {
				muialert(msg + "格式不正确!");
			}
			return false;
		}
	}
	return true;
}
/**
 * 比较日期 小于
 *
 * @param {Object}
 *            startDateStr
 * @param {Object}
 *            endDateStr
 * @return {TypeName} true:开始日期小于结束日期
 */
var compareDate = function(startDateStr, endDateStr) {
	// 将年月日分割保存在数组中
	var startDates = splitStr(startDateStr);
	var endDates = splitStr(endDateStr);
	// 转换为日期
	var startDate = new Date(startDates[0], parseInt(startDates[1] - 1, 10),
			startDates[2]);
	var endDate = new Date(endDates[0], parseInt(endDates[1] - 1, 10),
			endDates[2]);

	// return startDate<endDate?true:false;
	return startDate <= endDate ? true : false;// 2011-12-15更改
}

/**
 * 比较日期 小于等于
 *
 * @param {Object}
 *            startDateStr
 * @param {Object}
 *            endDateStr
 * @return {TypeName} true:开始日期小于等于结束日期
 */
var compareDate2 = function(startDateStr, endDateStr) {
	// 将年月日分割保存在数组中
	var startDates = splitStr(startDateStr);
	var endDates = splitStr(endDateStr);

	// 转换为日期
	var startDate = new Date(startDates[0], parseInt(startDates[1] - 1, 10),
			startDates[2]);
	var endDate = new Date(endDates[0], parseInt(endDates[1] - 1, 10),
			endDates[2]);

	return startDate > endDate ? false : true;
}

var compareDate5 = function(startDateStr, endDateStr) {
	// 将年月日分割保存在数组中
	var startDates = splitStr(startDateStr);
	var endDates = splitStr(endDateStr);

	// 转换为日期
	var startDate = new Date(startDates[0], parseInt(startDates[1] - 1, 10),
			startDates[2]);
	var endDate = new Date(endDates[0], parseInt(endDates[1] - 1, 10),
			endDates[2]);

	return startDate >= endDate ? false : true;
}

/**
 * 比较日期 等于
 *
 * @param {Object}
 *            startDateStr
 * @param {Object}
 *            endDateStr
 * @return {TypeName} true:开始日期等于结束日期
 */
var compareDate3 = function(startDateStr, endDateStr) {
	// 将年月日分割保存在数组中
	var startDates = splitStr(startDateStr);
	var endDates = splitStr(endDateStr);

	// 转换为日期
	var startDate = new Date(startDates[0], parseInt(startDates[1] - 1, 10),
			startDates[2]);
	var endDate = new Date(endDates[0], parseInt(endDates[1] - 1, 10),
			endDates[2]);

	return startDate.getTime() == endDate.getTime() ? true : false;
}
/**
 * 根据年月返回该月天数
 *
 * @param {Object}
 *            year
 * @param {Object}
 *            month
 */
var monthDay = function(year, month) {
	var feb = (year % 4 == 0) ? 29 : 28;
	var monthDay = new Array(31, feb, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	return monthDay[month - 1];
}

/**
 * 申报验证申报日期必须小于等于当天
 *
 * @param {Object}
 *            sbDate
 * @param {Object}
 *            today
 */
var sbData = function(sbDate, today) {
	if (!compareDate2(sbDate, today)) {

		return false;
	} else {
		return true;
	}

}

//返回申报不同类型
function getnsqxtype(nsqxdm)
{
	if (nsqxdm == undefined || nsqxdm == "") {
		return "未知";
	}
	if (nsqxdm == "11") { // 按次//return值开头为1
		return "次报";
	}else if (nsqxdm == "06") { // 按月return值开头为2
		return "月报";
	} else if (nsqxdm == "08") { // 按季度return值开头为3
		return "季报";
	} else if (nsqxdm == "09") { // 按半年return值开头为4
		return "半年报";
	} else if (nsqxdm == "10") { // 按年return值开头为5
		return "年报";
	} else {
		return "未知"+nsqxdm;
	}
}

/**
 * 按不同类型（次、月、季、半年、年），验证申报、终止日期
 *
 * @param {Object}
 *            skssqq
 * @param {Object}
 *            skssqz
 * @param {Object}
 *            today
 * @param {Object}
 *            nsqxdm
 * @return {TypeName} 通过返回true
 */
function qzDate(skssqq, skssqz, today, nsqxdm) {
	var succMsg = qzDateCheck(skssqq, skssqz, today, nsqxdm);
	if (succMsg == "ok") {
		return true;
	} else {
		AlertWrong(succMsg);
		return false;
	}
}
function qzDateCheck(skssqq, skssqz, today, nsqxdm) {
	var qDates = splitStr(skssqq);
	var zDates = splitStr(skssqz);
	var succMsg = "ok";
	if (skssqq == undefined || skssqq == "") {
		return "所属期起不能不能为空!";
	}
	if (skssqz == undefined || skssqz == "") {
		return "所属期止不能不能为空!";
	}
	if (skssqq.substring(0, 10) > skssqz.substring(0, 10)) {
		return "所属期起不能大于所属期止!";
	}
	if (nsqxdm == "11") { // 按次//return值开头为1
		if (parseInt(qDates[1], 10) != parseInt(zDates[1], 10)
				|| parseInt(qDates[2], 10) != parseInt(zDates[2], 10)) {
			return "按次申报，所属期起必须等于所属期止！";
		}
		return succMsg;
	}
	if (qDates[0] != zDates[0]) {
		return "所属期起和所属期止必须在同一年!";
	}
	if (nsqxdm == "06") { // 按月return值开头为2
		if (parseInt(qDates[1], 10) != parseInt(zDates[1], 10)) {
			return "按月申报，所属期起和所属期止必须在同一个月！";
		}
		if (parseInt(qDates[2], 10) != 1) {
			return "按月申报，所属期起必须为某月的第一天！";
		}
		if (monthDay(zDates[0], parseInt(zDates[1], 10)) != parseInt(zDates[2],
				10)) {
			return "按月申报，所属期止必须为某月的最后一天！";
		}
		return succMsg;
	} else if (nsqxdm == "08") { // 按季度return值开头为3
		// 季度信息
		if (!((parseInt(qDates[1], 10) >= 1 && parseInt(zDates[1], 10) <= 3)
				|| (parseInt(qDates[1], 10) >= 4 && parseInt(zDates[1], 10) <= 6)
				|| (parseInt(qDates[1], 10) >= 7 && parseInt(zDates[1], 10) <= 9) || (parseInt(
				qDates[1], 10) >= 10 && parseInt(zDates[1], 10) <= 12))) {
			return "按季申报，所属期起和所属期止必须在同一个季度！";
		}
		if (!(parseInt(qDates[2], 10) == 1 && (parseInt(qDates[1], 10) == 1
				|| parseInt(qDates[1], 10) == 4 || parseInt(qDates[1], 10) == 7 || parseInt(
				qDates[1], 10) == 10))) {
			return "按季申报，所属期起必须为某季度的第一天！";
		}
		if (!(zDates[2] == monthDay(zDates[0], parseInt(zDates[1], 10)) && (parseInt(
				zDates[1], 10) == 3
				|| parseInt(zDates[1], 10) == 6 || parseInt(zDates[1], 10) == 9 || parseInt(
				zDates[1], 10) == 12))) {
			return "按季申报，所属期止必须为某季度的最后一天！";
		}
		return succMsg;
	} else if (nsqxdm == "09") { // 按半年return值开头为4
		if (!((parseInt(qDates[1], 10) >= 1 && parseInt(zDates[1], 10) <= 6) || (parseInt(
				qDates[1], 10) >= 7 && parseInt(zDates[1], 10) <= 12))) {
			return "按半年申报，所属期起和所属期止必须在同一个半年！";
		}
		if (!(parseInt(qDates[2], 10) == 1 && (parseInt(qDates[1], 10) == 1 || parseInt(
				qDates[1], 10) == 7))) {
			return "按半年申报，所属期起必须为某半年的第一天！";
		}
		if (!(zDates[2] == monthDay(zDates[0], parseInt(zDates[1], 10)) && (parseInt(
				zDates[1], 10) == 6 || parseInt(zDates[1], 10) == 12))) {
			return "按半年申报，所属期止必须为某半年的最后一天！";
		}
		return succMsg;
	} else if (nsqxdm == "10") { // 按年return值开头为5
		if (qDates[0] != zDates[0]) {
			return "按年申报，所属期起和所属期止必须在同一年！";
		}
		if (!(parseInt(qDates[1], 10) == 1 && parseInt(qDates[2], 10) == 1)) {
			return "按年申报，所属期起必须为某年的第一天！";
		}
		if (!(parseInt(zDates[1], 10) == 12 && parseInt(zDates[2], 10) == 31)) {
			return "按年申报，所属期止必须为某年的最后一天！";
		}
		return succMsg;
		// } else if (nsqxdm == "11") { // 按次
		// if (skssqq != skssqz) {
		// return "按次申报，所属期起和所属期止为同一天！";
		// }
		// return succMsg;
	} else {
		if (qDates[0] != zDates[0]) {// return值开头为0
			return "所属期起和所属期止必须在同一年!";
		}
		return succMsg;
	}
}
/**征期校验
*/
function qzDatechk(ssqq, ssqz) {
	var qDates = splitStr(ssqq);
	var zDates = splitStr(ssqz);
	if (ssqq == undefined || ssqq == "") {
		return "所属期起不能不能为空!";
	}
	if (parseInt(qDates[2], 10) != 1) {
		return "所属期起必须为某月的第一天";
	}
	if (monthDay(zDates[0], parseInt(zDates[1], 10)) != parseInt(zDates[2], 10)) {
		return "所属期止必须为某月的最后一天";
	}
	if (ssqq == "" || ssqz == "") {
		return null;
	}
	if (qDates[0] != zDates[0]) {
		return "所属期起和所属期止必须在同一年!";
	}
	if (!((parseInt(qDates[1], 10) == 1 && parseInt(zDates[1], 10) == 3)
			|| (parseInt(qDates[1], 10) == 4 && parseInt(zDates[1], 10) == 6)
			|| (parseInt(qDates[1], 10) == 7 && parseInt(zDates[1], 10) == 9) || (parseInt(
			qDates[1], 10) == 10 && parseInt(zDates[1], 10) == 12))
			&& !((parseInt(qDates[1], 10) == 1 && parseInt(zDates[1], 10) == 6) || (parseInt(
					qDates[1], 10) == 7 && parseInt(zDates[1], 10) == 12))
			&& !((parseInt(qDates[1], 10) == 1 && parseInt(zDates[1], 10) == 12))
			&& parseInt(qDates[1], 10) != parseInt(zDates[1], 10)) {
		return "所属期不合法，必须为整年、半年、季或月";
	}
	if (ssqq.substring(0, 10) > ssqz.substring(0, 10)) {
		return "所属期起不能大于所属期止!";
	}
	return null;
}
function $chk(a) {
	return !!(a || a === 0)
}
/**
 * 空转为0.00数值
 */
function emptyToZ(obj) {
	if (typeof(obj) == "object") {
		if (!$chk(obj)) {
			return "0.00";
		} else if (!$chk(trimStr(obj.value))) {
			return "0.00";
		} else if (trimStr(obj.value) == "null") {
			return "0.00";
		} else {
			return trimStr(obj.value);
		}
	} else if (typeof(obj) == "number") {
		if (!$chk(obj)) {
			return "0.00";
		} else if (obj == "null") {
			return "0.00";
		} else if (obj == 0) {
			return "0.00";
		} else {
			return obj;
		}
	} else {
		if (!$chk(obj)) {
			return "0.00";
		} else if (!$chk(trimStr(obj))) {
			return "0.00";
		} else if (trimStr(obj) == "null") {
			return "0.00";
		} else if (trimStr(obj) == "0") {
			return "0.00";
		} else {
			return trimStr(obj);
		}
	}
}

/*******************************************************************************
 * 监控纳税人状态
 *
 * @param {}
 * nsrztDm 纳税人状态代码
 */
function checkNsrzt(nsrztDm) {
	if (nsrztDm == "07") {
		AlertWrong("纳税人处于注销状态，请重新办理税务登记");
		return false;
	}else if (nsrztDm == "08") {
		AlertWrong("纳税人处于非正常注销状态，请重新办理税务登记");
		return false;
	}else if (nsrztDm == "04") {
		AlertWrong("纳税人处于停业状态，可继续进行申报");
	}else if (nsrztDm == "05") {
		AlertWrong("纳税人处于非正常户状态，请进行非正常户解除，可继续进行申报");
	}else if (nsrztDm == "06") {
		AlertWrong("纳税人处于清算状态，可继续进行申报");
	}
	return true;
}
/*******************************************************************************
 * 获取期数
 *
 * @param {}
 *            nsqxDm 纳税期限代码
 * @param {}
 *            sfkssqq 税款所属期起
 * @param {}
 *            sfkssqz 税款所属期止
 * @param {}
 *            yxqq 有效期起
 * @param {}
 *            yxqz 有效期止
 * @return {} qs 期数
 */
function getQs(nsqxDm, sfkssqq, sfkssqz, yxqq, yxqz) {
	var qs = 1;// 默认1
	// 税款所属期在有效期内 正常算法取期数
	if (compareDate(yxqq, sfkssqq) && compareDate(sfkssqz, yxqz)) {
		if (nsqxDm == "06") {
			qs = 1;
		} else if (nsqxDm == "08") {
			qs = 3;
		} else if (nsqxDm == "09") {
			qs = 6
		} else if (nsqxDm == "10") {
			qs = 12;
		} else {
			qs = getYfc(sfkssqq, sfkssqz) + 1;
		}
		// 税款所属期起在有效期起之前，取有效期起与税款所属期止的月份差+1
	} else if (compareDate(sfkssqq, yxqq) && compareDate(sfkssqz, yxqz)) {
		qs = getYfc(yxqq, sfkssqz) + 1;
		// 税款所属期止在有效期止之后，取有效期起与税款所属期止的月份差+1
	} else if (compareDate(yxqq, sfkssqq) && compareDate(yxqz, sfkssqz)) {
		qs = getYfc(sfkssqq, yxqz) + 1;
		// 有效期在税款所属期之内，取有效期起止的月份差+1
	} else if (compareDate(sfkssqq, yxqq) && compareDate(yxqz, sfkssqz)) {
		qs = getYfc(yxqq, yxqz) + 1;
	}
	return qs;
}

/*******************************************************************************
 * 如果是负数，默认为0
 *
 * @param {}
 *            number
 * @return {}
 */
function isPositive(number) {
	if (number / 1 < 0) {
		number = "0.00";
	}
	return number;
}
/*******************************************************************************
 * 获取同年两日期月份差
 *
 * @param {}
 *            rqq 日期起
 * @param {}
 *            rqz 日期止
 * @return {} 月份差
 */
function getYfc(rqq, rqz) {
	var rqqs = splitStr(rqq);
	var rqzs = splitStr(rqz);
	return rqzs[1] - rqqs[1];
}
/*******************************************************************************
 *
 * 判断是否是Enter键
 *
 * @return 是：true 否：false
 */
function isEnterUp(e) {
	var code = e.keyCode ? e.keyCode : e.code;
	return code == 13;
}

$.submit = function(t) {
	mui.showLoading("数据提交中..", "div");
	t = t || {};
	//t.url = SysUtils.getUrl(t.url || "");
	var e = $("<form>").hide(),
		i = {};
	var n = {
		action: t.url,
		method: t.type || t.method || "POST",
		target: t.target		
	};
	if (t.target) {
		n.target = t.target
	}
	e.attr(n);
	if (t.data) {
		i = SysUtils.j2d(t.data)
	}
	/* if (pid !== undefined) {
		i.partitionId = pid
	} */
	for (var a in i) {
		e.append($("<input>").attr({
			type: "hidden",
			name: a,
			value: i[a]
		}))
	}
	mui.later(function() {mui.hideLoading(function() {});}, 1000);
	e.appendTo("body").submit()
};
var SysUtils ={
	a2d: function(t, e) {
		var i = {},
			n, a;
		e = e + "[_IDX_]";
		for (var r = 0; r < t.length; r++) {
			a = t[r];
			n = e.replace("_IDX_", r);
			if ($.isPlainObject(a)) {
				$.extend(i, this.j2d(a, n, n.indexOf("Map", n.length - 3) !== -1))
			} else if ($.isArray(a)) {
				$.extend(i, this.a2d(a, n))
			} else {
				i[n] = a
			}
		}
		return i
	},
	j2d: function(t, e, i) {
		var n = {},
			a, r;
		if (e) {
			e = e + (i ? "[_KEY_]" : "._KEY_")
		} else {
			e = "_KEY_"
		}
		for (var o in t) {
			r = t[o];
			a = e.replace("_KEY_", o);
			if ($.isPlainObject(r)) {
				$.extend(n, this.j2d(r, a, o.indexOf("Map", o.length - 3) !== -1))
			} else if ($.isArray(r)) {
				$.extend(n, this.a2d(r, a))
			} else {
				n[a] = r
			}
		}
		return n
	},
	j2fArray: function(t, e, i, n) {
		var a = prefix + key,
			r = i[key];
		for (var o = 0; o < r.length; o++) {
			var s = r[o];
			a = a + "[" + o + "]";
			if ($.isPlainObject(r)) {
				this.j2f(t, a + ".", s, n)
			} else if ($.isArray(r)) {
				this.j2fArray(t, a, s, n)
			} else {
				var l = t.find('[name="' + a + '"]');
				if (l.is("input, select, textarea")) {
					l.val(r)
				} else {
					if (n) {
						l.text(r)
					} else {
						l.html(r)
					}
				}
				l.attr("title", r)
			}
		}
	},
	v2f: function(t, e, i, n) {
		var a = t.find('[name="' + e + '"]');
		if (a.is("input, select, textarea")) {
			a.val(i)
		} else {
			if (n.encode) {
				a.text(i)
			} else {
				a.html(i)
			}
		}
		a.attr("title", i)
	},
	j2f: function(t, e, i, n) {
		for (var a in i) {
			var r = e + a,
				o = i[a];
			if ($.isPlainObject(o)) {
				this.j2f(t, r + ".", o, n)
			} else if ($.isArray(o)) {
				this.j2fArray(t, r, o, n)
			} else {
				this.v2f(t, r, o, n)
			}
		}
	},
	REG: /(.*?)\[(\d+)+\]/,
	f2j: function(t, e, i) {
		var n = t[0],
			a = this.REG.exec(n),
			r = a && a.length > 0,
			n = r ? a[1] : n;
		data = i[n];
		t = t.slice(1);
		if (!data) {
			data = r ? [] : {};
			i[n] = data
		}
		if (!t || !t.length) {
			if (r) {
				var o = data;
				for (var s = 3; s < a.length - 1; s++) {
					data[a[s - 1]] = o = data[a[s - 1]] || []
				}
				o[a[a.length - 1]] = e
			} else {
				i[n] = e
			}
		} else {
			i[n] = this.f2j(t, e, data)
		}
		return i
	}
};
//ajax
function ajaxs(href,data,callback,config){
		mui.showLoading("数据处理中..", "div");
		mui.ajax(href, $.extend(true,{}||config,{
			type: 'POST',
			timeout: 60000,
			data: data || {},
			async: false,
			headers: {
				'Content-Type': 'application/json'
			},
			success: function(res) {
				
				if('SESSION_TIMEOUT'== res.content){
					window.location.reload();
					return;
				}
				callback(res);
			},
			error: function(xhr, type, errorThrown) {
				if(config!=undefined&& config.error!=undefined){
					 config.error && config.error.call(this, xhr, type, errorThrown);
				}else{
				AlertWrong('请检查网络是否通畅,或联系管理员');
				}
			}
			/*,
			beforeSend:function(){
			
			}*/
					
		}));
	mui.later(function() {mui.hideLoading(function() {});}, 1500);
}
//判断数据是否为空
function ifnull(data){
  var ifs=(data == ""|| data == null || data == undefined || data == "null" || JSON.stringify(data)== "[]"||JSON.stringify(data) =="{}");
  return ifs;
}

 var zjlx=[{"SFZJLX_DM":"201","SFZJLXMC":"居民身份证"},{"SFZJLX_DM":"235","SFZJLXMC":"香港特别行政区护照"},
{"SFZJLX_DM":"236","SFZJLXMC":"澳门特别行政区护照"},{"SFZJLX_DM":"233","SFZJLXMC":"外国人永久居留身份证（外国人永久居留证）"},
{"SFZJLX_DM":"227","SFZJLXMC":"中国护照"},{"SFZJLX_DM":"200","SFZJLXMC":"个人"},
{"SFZJLX_DM":"202","SFZJLXMC":"军官证"},
{"SFZJLX_DM":"208","SFZJLXMC":"外国护照"},{"SFZJLX_DM":"209","SFZJLXMC":"港澳同胞回乡证"},
{"SFZJLX_DM":"210","SFZJLXMC":"港澳居民来往内地通行证"},{"SFZJLX_DM":"211","SFZJLXMC":"台胞证"},
{"SFZJLX_DM":"212","SFZJLXMC":"中华人民共和国往来港澳通行证"},{"SFZJLX_DM":"213","SFZJLXMC":"台湾居民来往大陆通行证"},
{"SFZJLX_DM":"214","SFZJLXMC":"大陆居民往来台湾通行证"},{"SFZJLX_DM":"215","SFZJLXMC":"外国人居留证"},
{"SFZJLX_DM":"219","SFZJLXMC":"香港永久性居民身份证"},{"SFZJLX_DM":"220","SFZJLXMC":"台湾身份证"},
{"SFZJLX_DM":"221","SFZJLXMC":"澳门特别行政区永久性居民身份证"},{"SFZJLX_DM":"222","SFZJLXMC":"外国人身份证件"},
{"SFZJLX_DM":"237","SFZJLXMC":"中华人民共和国港澳居民居住证"},{"SFZJLX_DM":"238","SFZJLXMC":"中华人民共和国台湾居民居住证"}
];
